// gentrace.h
// module to create stack traces; implementation is nonportable
// this is a major rewrite of a previous module by the same name; the
//   earlier module was primarily for use in Melee, while this new
//   rewrite is for the Feudal-C usability study

#ifndef __GENTRACE_H
#define __GENTRACE_H

// represents a single trace
struct StackTrace {
  void const **trace;     // array of return addresses
  int length;             // size of 'trace' array, in ptr-sized words
  int next;               // index of next unused array entry (initially 0)

  // add another address
  void addAddr(void const *eip);
};


// generate a stack trace for stack up to calling function
void trace(StackTrace &dest);


// trace from given frame pointer (FP) and program counter (PC);
// PC may be null
void trace(StackTrace &dest, void const *FP, void const *PC);


#endif // __GENTRACE_H

