// stackbot.h
// simple module to retrieve the address of the bottom
//   (cold end) of the call stack

#ifndef __STACKBOT_H
#define __STACKBOT_H

// the interface of a global variable is chosen over a fn that
// returns the value, for efficiency reasons (i.e. I expect that
// this value will be used repeatedly in pointer validity tests
// during, say, stack traces)

// pointer to stack bottom; the address typically points to the
// word just *below* the last accessible stack address, so this
// pointer shouldn't itself be deferenced
extern void *stackBottom;


// call this routine early in the program's life, so the stack
// can be assumed to have grown only very little; this call sets
// 'stackBottom'
void initStackBottom();


#endif // __STACKBOT_H

